unit CopyEg2U;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    BtnCopy: TButton;
    EdtCopyFrom: TEdit;
    EdtCopyTo: TEdit;
    ProgressBar: TProgressBar;
    procedure BtnCopyClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses
  CopyU2;

{$R *.DFM}

procedure FileCopyCallBack(Position, Size: LongInt);
var
  Factor: Longint;
begin
  { Progress bars have a max value of 64k-1 }
  { Scale our values down if necessary }
  Factor := Size div High(TProgressRange);
  if Factor > 1 then
  begin
    Size := Size div High(TProgressRange);
    Position := Position div High(TProgressRange);
  end;
  Form1.ProgressBar.Max := Size;
  Form1.ProgressBar.Position := Position;
end;

procedure TForm1.BtnCopyClick(Sender: TObject);
begin
  BtnCopy.Enabled := False;
  FileCopy(EdtCopyFrom.Text, EdtCopyTo.Text, FileCopyCallBack);
  BtnCopy.Enabled := True;
end;

initialization
  RegisterClass(TLabel);
end.
