unit SaverU3;

interface

uses
  WinProcs, WinTypes, Messages, SysUtils, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls;

type
  TMainForm = class(TForm)
    Button1: TButton;
    Button2: TButton;
    ColorDialog1: TColorDialog;
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

uses
  ChoiceU, TypInfo, RTTIUnit;

procedure TMainForm.Button2Click(Sender: TObject);
begin
  if ColorDialog1.Execute then
    Color := ColorDialog1.Color
end;

procedure TMainForm.Button1Click(Sender: TObject);
begin
  with ChoiceForm, ListBox1 do
    if ShowModal <> mrCancel then
      Self.BorderStyle :=
        TFormBorderStyle(GetEnumValue(
          TypeInfo(TFormBorderStyle), Items[ItemIndex]));
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  ReadProps(Self, 'Form1', ['BorderStyle', 'Color',
    'Top', 'Left', 'Height', 'Width']);
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  WriteProps(Self, 'Form1', ['BorderStyle', 'Color',
    'Top', 'Left', 'Height', 'Width']);
end;

end.
